<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="商品名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入商品名称" />
      </el-form-item>
      <el-form-item label="商品价格" prop="price">
        <el-input v-model="formData.price" placeholder="请输入商品价格" />
      </el-form-item>
      <el-form-item label="商品简介" prop="introduction">
        <el-input v-model="formData.introduction" placeholder="请输入商品简介" />
      </el-form-item>
      <el-form-item label="显示顺序" prop="sort">
        <el-input type="number" v-model="formData.sort" placeholder="商品在后台列表显示的顺序" />
      </el-form-item>
      <el-form-item label="商品封面图" prop="picUrl">
        <UploadImg v-model="formData.picUrl" />
      </el-form-item>
      <el-form-item label="商品轮播图" prop="sliderPicUrls">
        <UploadImg v-model="formData.sliderPicUrls" />
      </el-form-item>
      <el-form-item label="商品详情">
        <Editor v-model="formData.description" height="150px" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as ProductApi from '@/api/member/product'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  keyword: undefined,
  introduction: undefined,
  description: '',
  categoryId: undefined,
  brandId: undefined,
  picUrl: undefined,
  sliderPicUrls: undefined,
  videoUrl: undefined,
  unit: undefined,
  sort: undefined,
  status: undefined,
  price: undefined,
  stock: undefined
})
const formRules = reactive({
  name: [{ required: true, message: '商品名称不能为空', trigger: 'blur' }],
  price: [{ required: true, message: '商品价格不能为空', trigger: 'blur' }],
  // picUrl: [{ required: true, message: '商品图片不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ProductApi.getProduct(id)
      if (!formData.value.description) {
        formData.value.description = ''
      }
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ProductApi.ProductVO
    if (formType.value === 'create') {
      await ProductApi.createProduct(data)
      message.success(t('common.createSuccess'))
    } else {
      await ProductApi.updateProduct(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    keyword: undefined,
    introduction: undefined,
    description: '',
    categoryId: undefined,
    brandId: undefined,
    picUrl: undefined,
    sliderPicUrls: undefined,
    videoUrl: undefined,
    unit: undefined,
    sort: undefined,
    status: undefined,
    price: undefined,
    stock: undefined
  }
  formRef.value?.resetFields()
}
</script>
